searchNodes=[{"type":"behaviour","title":"Kungfuig","doc":"The behaviour defining the dynamic config provider. Kungfuig provides a plugagble drop-in support for live configurations. Examples Kungfuig.Supervisor . start_link ( ) Kungfuig . config ( ) #⇒ %{env: %{kungfuig: []}, system: %{}} Kungfuig . config ( :env ) #⇒ %{kungfuig: []} Application . put_env ( :kungfuig , :foo , 42 ) Kungfuig . config ( :env ) #⇒ %{kungfuig: [foo: 42]} The configuration is frequently updated.","ref":"Kungfuig.html"},{"type":"function","title":"Kungfuig.__struct__/0","doc":"The config that is manages by this behaviour is a simple map","ref":"Kungfuig.html#__struct__/0"},{"type":"function","title":"Kungfuig.config/2","doc":"","ref":"Kungfuig.html#config/2"},{"type":"callback","title":"Kungfuig.start_link/1","doc":"","ref":"Kungfuig.html#c:start_link/1"},{"type":"callback","title":"Kungfuig.update_config/1","doc":"The actual implementation to update the config","ref":"Kungfuig.html#c:update_config/1"},{"type":"type","title":"Kungfuig.callback/0","doc":"The callback to be used for subscibing to config updates. Might be an anonymous function, an {m, f} tuple accepting a single argument, or a process identifier accepting call , cast or simple message ( :info .)","ref":"Kungfuig.html#t:callback/0"},{"type":"type","title":"Kungfuig.config/0","doc":"The config map to be updated and exposed through callback","ref":"Kungfuig.html#t:config/0"},{"type":"type","title":"Kungfuig.option/0","doc":"The option that can be passed to start_link/1 function","ref":"Kungfuig.html#t:option/0"},{"type":"type","title":"Kungfuig.t/0","doc":"The start_link/1 function wrapping the GenServer.start_link/3","ref":"Kungfuig.html#t:t/0"},{"type":"behaviour","title":"Kungfuig.Backend","doc":"The scaffold for the backend watching the external config source.","ref":"Kungfuig.Backend.html"},{"type":"callback","title":"Kungfuig.Backend.get/1","doc":"The implementation of the call to remote that retrieves the data","ref":"Kungfuig.Backend.html#c:get/1"},{"type":"callback","title":"Kungfuig.Backend.key/0","doc":"The key this particular config would be stored under, defaults to module name","ref":"Kungfuig.Backend.html#c:key/0"},{"type":"callback","title":"Kungfuig.Backend.report/1","doc":"The implementation of error reporting","ref":"Kungfuig.Backend.html#c:report/1"},{"type":"callback","title":"Kungfuig.Backend.transform/1","doc":"The transformer that converts the retrieved data to internal representation","ref":"Kungfuig.Backend.html#c:transform/1"},{"type":"behaviour","title":"Kungfuig.Validator","doc":"Generic validator encapsulation. Default implementation is NimbleOptions .","ref":"Kungfuig.Validator.html"},{"type":"callback","title":"Kungfuig.Validator.doc/1","doc":"Generates a documentation for expected options","ref":"Kungfuig.Validator.html#c:doc/1"},{"type":"callback","title":"Kungfuig.Validator.validate/1","doc":"Validates given options with the schema, provided by the implementation of this behaviour","ref":"Kungfuig.Validator.html#c:validate/1"},{"type":"extras","title":"Kungfuig","doc":"","ref":"readme.html"},{"type":"extras","title":"Kungfuig - Intro","doc":"Live config supporting many different backends. Kungfuig ( pronounced: [ˌkʌŋˈfig]) provides an easy way to plug live configuration into everything. It provides backends for env and system and supports custom backends.","ref":"readme.html#intro"},{"type":"extras","title":"Kungfuig - Installation","doc":"def deps do [ { :kungfuig , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Kungfuig - Using","doc":"Kungfuig is the easy way to read the external configuration from sources that are not controlled by the application using it, such as Redis , or Database . Here is the example of backend implementation for the config read from external MySQL . defmodule MyApp.Kungfuig.MySQL do @moduledoc false use Kungfuig.Backend @impl Kungfuig.Backend def get ( _meta ) do with { :ok , host } &lt;- System . fetch_env ( &quot;MYSQL_HOST&quot; ) , { :ok , db } &lt;- System . fetch_env ( &quot;MYSQL_DB&quot; ) , { :ok , user } &lt;- System . fetch_env ( &quot;MYSQL_USER&quot; ) , { :ok , pass } &lt;- System . fetch_env ( &quot;MYSQL_PASS&quot; ) , { :ok , pid } when is_pid ( pid ) &lt;- MyXQL . start_link ( hostname : host , database : db , username : user , password : pass ) , result &lt;- MyXQL . query! ( pid , &quot;SELECT * FROM some_table&quot; ) do GenServer . stop ( pid ) result = result . rows |&gt; Flow . from_enumerable ( ) |&gt; Flow . map ( fn [ _ , field1 , field2 , _ , _ ] -&gt; { field1 , field2 } end ) |&gt; Flow . partition ( key : &amp; elem ( &amp;1 , 0 ) ) |&gt; Flow . reduce ( fn -&gt; %{ } end , fn { field1 , field2 } , acc -&gt; Map . update ( acc , String . to_existing_atom ( field1 ) , [ field2 ] , &amp; [ field2 | &amp;1 ] ) end ) Logger . info ( &quot;Loaded \#{ Enum . count ( result ) } values from &quot; &lt;&gt; host ) { :ok , result } else :error -&gt; Logger . warn ( &quot;Skipped reconfig, one of MYSQL_{HOST,DB,USER,PASS} is missing&quot; ) :ok error -&gt; Logger . error ( &quot;Reconfiguring failed. Error: &quot; &lt;&gt; inspect ( error ) ) { :error , error } end end end","ref":"readme.html#using"},{"type":"extras","title":"Kungfuig - Testing","doc":"Simply implement a stub returning an expected config and you are all set. defmodule MyApp.Kungfuig.Stub do @moduledoc false use Kungfuig.Backend @impl Kungfuig.Backend def get ( _meta ) , do : %{ foo : :bar , baz : [ 42 ] } end","ref":"readme.html#testing"},{"type":"extras","title":"Kungfuig - Changelog","doc":"0.4.3 — fix a bug with hardcoded names ( Supervisor and Blender ) 0.4.2 — allow imminent: true option to Kungfuig.Backend 0.4.0 — allow named Kungfuig.Supervisor (thanks @vbroskas) 0.3.0 — allow validation through NimbleOptions (per backend and global) 0.2.0 — scaffold for backends + several callbacks (and the automatic one for Blender )","ref":"readme.html#changelog"},{"type":"extras","title":"Kungfuig - Documentation","doc":"","ref":"readme.html#documentation"}]